﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Boats
{
    internal class EntityCatamaran : EntityBoat
    {
        /// <summary>
        /// Дополнительный цвет
        /// </summary>
        public Color DopColor { get; set; }
        /// <summary>
        /// Признак наличия поплавков
        /// </summary>
        public bool Bobbers { get; private set; }
        /// <summary>
        /// Признак наличия паруса
        /// </summary>
        public bool Sail { get; private set; }
        /// <summary>
        /// Инициализация свойств
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес катамарана</param>
        /// <param name="bodyColor">Цвет корпуса</param>
        /// <param name="dopColor">Дополнительный цвет</param>
        /// <param name="bobbers">Признак наличия поплавков</param>
        /// <param name="sail">Признак наличия паруса</param>
        public EntityCatamaran(int speed, float weight, Color bodyColor,
            Color dopColor, bool bobbers, bool sail) :
            base(speed, weight, bodyColor)
        {
            DopColor = dopColor;
            Bobbers = bobbers;
            Sail = sail;
        }
        public void SetDopColor(Color color)
        {
            DopColor = color;
        }
    }
}
